
/***************************************************************************
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
                   CommandReq -- Command File Requester
                 Copyright 1987 Jay Johnson and Sam Morse
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
                   Written by Jay Johnson and Sam Morse
                      Version 1.0 July 17th 1987
***************************************************************************
This program is public domain. The authors assume no liability for missuse
of this program and are not liable for any damage incurred during use. Use
at your own risk.

This program may be used in commercial software ONLY with the written consent
of the original authors.

Please send modifications of this code to the below address so that we may
better control the evalution and insure that the best revisions are included
in updates.
****************************************************************************/
/* commandreq.h */
/* executing a command requester definition */

/*  Definitions for Gadget ID numbers               */


#define YES 650
#define STOP 651
#define NO 652
#define FUNCT 654

SHORT command_pairs[] = {
  0,     0,   
  209,     0,
  209,     9,
  0,     9,
  0,     0    
};
struct Border command_bord = {
  -1,  -1,  2,  1,  JAM2,  5,  (SHORT *)&command_pairs,  NULL};


UBYTE command_sbuf_1[256] = " ";
UBYTE command_ubuf_1[256];

struct StringInfo command_txstr_1 = {
  command_sbuf_1, command_ubuf_1, 0, 255, 0, 0, 1, 26, 16,12, 0x0, 0,0x0};


struct Gadget command = {
 NULL, 11, 21, 208, 8,GADGHCOMP,RELVERIFY,STRGADGET,(APTR)&command_bord,
  NULL,   NULL,  0x0,  (APTR)&command_txstr_1,  FUNCT,  NULL};


/**********************************************************************
 *  IntuiTexts for the trace selection requester.
 **********************************************************************/

struct IntuiText commandsel_text[] =
 {
   {
     2,0,JAM1,6,-34,&TxtAt_Plain,(UBYTE *)"Execute this command:",&commandsel_text[1]
   },
   {
     1, 2,JAM2,22,5,&TxtAt_Plain,(UBYTE *)"YES",&commandsel_text[2]
   },
   {
     1, 2,JAM2,91,5,&TxtAt_Plain,(UBYTE *)"STOP!",&commandsel_text[3]
   },
   {
     1, 2,JAM2,177,5,&TxtAt_Plain,(UBYTE *)"NO",NULL
   },
};

/**********************************************************************
 *  Gadget Structure definition for the sense length requester.
 **********************************************************************/

struct Gadget commandreqgad[] =
 {
   {
      &commandreqgad[1],5,40,70,16, GADGIMAGE,RELVERIFY,BOOLGADGET,
      (APTR)&midwb_img,NULL,&commandsel_text,0xffff,NULL,YES,NULL
   },
   {
      &commandreqgad[2],80,40,70,16, GADGIMAGE,RELVERIFY,BOOLGADGET,
      (APTR)&midwb_img,NULL,NULL,0xffff,NULL,STOP,NULL
   },
   {
      &command,155,40,70,16, GADGIMAGE,RELVERIFY,BOOLGADGET,
      (APTR)&midwb_img,NULL,NULL,0xffff,NULL,NO,NULL
   },
};


SHORT commandreq_Pairs[] = {
  0,     0,   
  230,     0,
  230,     60,
  0,     60,
  0,     0    
};

struct Border commandreq_bord = {
  0,0,2,3,JAM2,5,(SHORT *)&commandreq_Pairs, NULL};

struct Requester commandreq = {
   NULL,0,0,231,61,0,0,&commandreqgad[0],&commandreq_bord,NULL,
   POINTREL,0x1,NULL,NULL,NULL};


struct NewWindow commandreqwin = {
  200,50,231,61,0,1,GADGETUP|REQCLEAR,BORDERLESS|SMART_REFRESH
  ,NULL,NULL,NULL,NULL,NULL,0,0,0,0,WBENCHSCREEN};

